import { world, system } from "@minecraft/server";

world.afterEvents.itemStartUse.subscribe((event) => {
    const player = event.source;

    // Get the equipment component for the player
    const equipment = player.getComponent('equippable');

    // Get the selected item from the player's mainhand
    const selectedItem = equipment.getEquipment('Mainhand');

    // Check if the selected item is 'bs:exp_book_1'
    if (selectedItem && (selectedItem.typeId === 'bs:exp_book_1')) {

        if (event.itemStack.typeId === "bs:exp_book_1") {
            const callbackId = system.runInterval(() => {
                player.runCommandAsync("xp 160 @p");
                player.runCommandAsync("particle minecraft:totem_particle ~~1~");
                system.clearRun(callbackId); // Stop the interval after giving XP

                // Play a sound at the player's location
                player.runCommandAsync(`playsound random.levelup @p ${player.location.x} ${player.location.y} ${player.location.z}`);
            }, 0);
        }

        if (player.getGameMode() !== "creative") {
            if (selectedItem.amount > 1) {
                selectedItem.amount -= 1;
                equipment.setEquipment('Mainhand', selectedItem);
            } else {
                // Clear the slot if only 1 item left
                equipment.setEquipment('Mainhand', undefined);
            }
        }
    }
});

world.afterEvents.itemStartUse.subscribe((event) => {
    const player = event.source;

    // Get the equipment component for the player
    const equipment = player.getComponent('equippable');

    // Get the selected item from the player's mainhand
    const selectedItem = equipment.getEquipment('Mainhand');

    // Check if the selected item is 'bs:exp_book_1'
    if (selectedItem && (selectedItem.typeId === 'bs:exp_book_2')) {

        if (event.itemStack.typeId === "bs:exp_book_2") {
            const callbackId = system.runInterval(() => {
                player.runCommandAsync("xp 315 @p");
                player.runCommandAsync("particle minecraft:totem_particle ~~1~");
                system.clearRun(callbackId); // Stop the interval after giving XP

                // Play a sound at the player's location
                player.runCommandAsync(`playsound random.levelup @p ${player.location.x} ${player.location.y} ${player.location.z}`);
            }, 0);
        }

        if (player.getGameMode() !== "creative") {
            if (selectedItem.amount > 1) {
                selectedItem.amount -= 1;
                equipment.setEquipment('Mainhand', selectedItem);
            } else {
                // Clear the slot if only 1 item left
                equipment.setEquipment('Mainhand', undefined);
            }
        }
    }
});

world.afterEvents.itemStartUse.subscribe((event) => {
    const player = event.source;

    // Get the equipment component for the player
    const equipment = player.getComponent('equippable');

    // Get the selected item from the player's mainhand
    const selectedItem = equipment.getEquipment('Mainhand');

    // Check if the selected item is 'bs:exp_book_1'
    if (selectedItem && (selectedItem.typeId === 'bs:exp_book_3')) {

        if (event.itemStack.typeId === "bs:exp_book_3") {
            const callbackId = system.runInterval(() => {
                player.runCommandAsync("xp 550 @p");
                player.runCommandAsync("particle minecraft:totem_particle ~~1~");
                system.clearRun(callbackId); // Stop the interval after giving XP

                // Play a sound at the player's location
                player.runCommandAsync(`playsound random.levelup @p ${player.location.x} ${player.location.y} ${player.location.z}`);
            }, 0);
        }

        if (player.getGameMode() !== "creative") {
            if (selectedItem.amount > 1) {
                selectedItem.amount -= 1;
                equipment.setEquipment('Mainhand', selectedItem);
            } else {
                // Clear the slot if only 1 item left
                equipment.setEquipment('Mainhand', undefined);
            }
        }
    }
});

world.afterEvents.itemStartUse.subscribe((event) => {
    const player = event.source;

    // Get the equipment component for the player
    const equipment = player.getComponent('equippable');

    // Get the selected item from the player's mainhand
    const selectedItem = equipment.getEquipment('Mainhand');

    // Check if the selected item is 'bs:exp_book_1'
    if (selectedItem && (selectedItem.typeId === 'bs:the_great_book_experience')) {

        if (event.itemStack.typeId === "bs:the_great_book_experience") {
            const callbackId = system.runInterval(() => {
                player.runCommandAsync("xp 1395 @p");
                player.runCommandAsync("particle minecraft:totem_particle ~~1~");
                system.clearRun(callbackId); // Stop the interval after giving XP

                // Play a sound at the player's location
                player.runCommandAsync(`playsound random.levelup @p ${player.location.x} ${player.location.y} ${player.location.z}`);
            }, 0);
        }

        if (player.getGameMode() !== "creative") {
            if (selectedItem.amount > 1) {
                selectedItem.amount -= 1;
                equipment.setEquipment('Mainhand', selectedItem);
            } else {
                // Clear the slot if only 1 item left
                equipment.setEquipment('Mainhand', undefined);
            }
        }
    }
});
